#ifndef RATEMOVE_H_INCLUDED
#define RATEMOVE_H_INCLUDED

#include <iostream>
#include <cmath>        /* outils mathematiques */
#include <algorithm>
#include <stdlib.h>     /* srand, rand */
#include <vector>
#include "Geometry.h"


/* Rate */
// calcul le taux de naissance a partir des traits
double birthRate(double const& traitPosition, std::vector<double> const& traitPhenotype,
                 std::vector<double> const& parameters);

//calcul le noyau d'interaction pour un taux positif
double positiveInteractionKernel(double const& traitPosition1, std::vector<double> const& traitPhenotype1,
                                 std::vector<double> const& parameters1, double const& traitPosition2,
                                 std::vector<double> const& traitPhenotype2, std::vector<double> const& parameters2);

//calcul le taux de mort a partir des traits
double deathRate(double const& traitPosition, std::vector<double> const& traitPhenotype,
                 std::vector<double> const& parameters);

// calcul le noyau de competition
double competitionKernel(double const& traitPosition1, std::vector<double> const& traitPhenotype1,
                         std::vector<double> const& parameters1, double const& traitPosition2,
                         std::vector<double> const& traitPhenotype2, std::vector<double> const& parameters2);

// calcul le noyau de competition pour l'acces aux mutualistes
double competitionMutKernel(double const& traitPosition1, std::vector<double> const& traitPhenotype1,
                         std::vector<double> const& parameters1, double const& traitPosition2,
                         std::vector<double> const& traitPhenotype2, std::vector<double> const& parameters2);

// calcul du trait du nouveau mutant
std::vector<double> mutantTraitPhenotype(std::vector<double> const& traitPhenotype, double const& traitPosition,
                                         std::vector<double> const& parameters, Geometry const& geometrySpace);

/* Move */
//calcul du coefficient de diffusion
double coefDiffusion(double const& traitPosition, std::vector<double> const& traitPhenotype,
                     std::vector<double> const& parameters);

//mouvement pendant un temps timeInterval pendant la vie de l'Entity
double liveShifting(double const& timeInterval, Geometry const& geometrySpace,
                    double const& traitPosition,
                    std::vector<double> const& traitPhenotype, std::vector<double> const& parameters);

//deplacement a la naissance de l'entity
double birthShifting(double const& traitPosition, std::vector<double> const& traitPhenotype,
                     std::vector<double> const& parameters, Geometry const& geometrySpace);

#endif // RATEMOVE_H_INCLUDED
